 
/*------------------------------------------------------------------------
   File        : Doctor
   Purpose     : 
   Syntax      : 
   Description : 
   Author(s)   : Gerry.Winning
   Created     : Sun Mar 08 20:05:13 EDT 2015
   Notes       : 
 ----------------------------------------------------------------------*/
  
USING Progress.Lang.*.
BLOCK-LEVEL ON ERROR UNDO, THROW. 

CLASS App.DoctorDBUtil: 
   
  /* fake DB table to avoid a demo DB */
  DEFINE STATIC TEMP-TABLE Doctor NO-UNDO 
    FIELD Doctor_no  AS INTEGER 
    FIELD Doctor     AS CHARACTER  
    FIELD ActorName  AS CHARACTER 
    FIELD SeriesType AS CHARACTER 
    FIELD StartYear  AS INTEGER  
    FIELD EndYear    AS INTEGER
    FIELD Bio        AS CHARACTER .
    
  {DoctorTT.i}

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/
		
  CONSTRUCTOR PUBLIC DoctorDBUtil (  ):
    SUPER ().
    xxCreateFakeDBData().
		
  END CONSTRUCTOR.


  /*------------------------------------------------------------------------------
   
  ------------------------------------------------------------------------------*/
  METHOD PUBLIC VOID getDoctors(OUTPUT TABLE ttDoctor):
    getDoctors('', '', OUTPUT TABLE ttDoctor).
  END METHOD.
      
  METHOD PUBLIC VOID getDoctors( 
    pFilterField AS CHARACTER, 
    pFilterValue AS CHARACTER, 
    OUTPUT TABLE ttDoctor):
     
    DEFINE VARIABLE hQuery  AS HANDLE    NO-UNDO. 
    DEFINE VARIABLE vFilter AS CHARACTER NO-UNDO. 
    
    CREATE QUERY hQuery.     
    hQuery:SET-BUFFERS (BUFFER Doctor:HANDLE).
    
    IF pFilterField <> '' THEN 
      ASSIGN vFilter = " WHERE Doctor." + pFilterField + " = '" + pFilterValue + "'".
     
    hQuery:QUERY-PREPARE ("FOR EACH Doctor " + vFilter).  
    hQuery:QUERY-OPEN ().
    
    hQuery:GET-FIRST ().
    REPEAT WHILE NOT hQuery:QUERY-OFF-END:
      CREATE ttDoctor.
      BUFFER-COPY Doctor TO ttDoctor.
      hQuery:GET-NEXT (). 
    END.
    
    RETURN.

  END METHOD.

  /*------------------------------------------------------------------------------
   Purpose:
   Notes:
  ------------------------------------------------------------------------------*/

  METHOD PUBLIC VOID xxCreateFakeDBData(  ):
    IF CAN-FIND (FIRST Doctor) THEN 
      RETURN.
	 
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 1
      Doctor.Doctor     = 'First Doctor'
      Doctor.ActorName  = 'William Hartnell'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1963
      Doctor.EndYear    = 1966
      Doctor.Bio        = 'William Henry Hartnell (January 1908 - 23 April 1975) was an English actor known for his role as the first incarnation of the Doctor in Doctor Who.'
      .
      
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 2
      Doctor.Doctor     = 'Second Doctor'
      Doctor.ActorName  = 'Patrick Troughton'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1966
      Doctor.EndYear    = 1969
      Doctor.Bio        = 'Patrick George Troughton (25 March 1920 - 28 March 1987) was an English actor most widely known for his roles in fantasy, science fiction, and horror films, particularly in his role as the second incarnation of the Doctor in the long-running British science-fiction television series Doctor Who'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 3
      Doctor.Doctor     = 'Third Doctor'
      Doctor.ActorName  = 'Jon Pertwee'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1970
      Doctor.EndYear    = 1974
      Doctor.Bio        = 'John Devon Roland "Jon" Pertwee (7 July 1919 - 20 May 1996) was an English actor, entertainer and cabaret performer.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 4
      Doctor.Doctor     = 'Fourth Doctor'
      Doctor.ActorName  = 'Tom Baker'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1974
      Doctor.EndYear    = 1981
      Doctor.Bio        = 'Thomas Stewart "Tom" Baker (born 20 January 1934) is an English actor. He is best known for his role as the fourth incarnation of the Doctor in the science fiction series Doctor Who from 1974 to 1981, a longer tenure than any other actor, and for his narration of the comedy series Little Britain. In a 2005 poll, his voice was found to be the fourth most recognisable in Britain.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 5
      Doctor.Doctor     = 'Fifth Doctor'
      Doctor.ActorName  = 'Peter Davison'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1982
      Doctor.EndYear    = 1984
      Doctor.Bio        = 'Peter Davison (born Peter Malcolm Gordon Moffett on 13 April 1951) is an English actor, best known for his roles as Tristan Farnon in the television version of James Herriot~'s All Creatures Great and Small, and as the fifth incarnation of the Doctor in Doctor Who.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 6
      Doctor.Doctor     = 'Sixth Doctor'
      Doctor.ActorName  = 'Colin Baker'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1984
      Doctor.EndYear    = 1986
      Doctor.Bio        = 'Colin Baker (born 8 June 1943) is an English actor, who is known as Paul Merroney in The Brothers from 1974 to 1976 and as the sixth incarnation of The Doctor in the long-running science fiction television series Doctor Who.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 7
      Doctor.Doctor     = 'Seventh Doctor'
      Doctor.ActorName  = 'Sylvester McCoy'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1987
      Doctor.EndYear    = 1989
      Doctor.Bio        = 'Sylvester McCoy (born Percy James Patrick Kent-Smith: 20 August 1943) is a Scottish actor. As a comic act and busker he appeared regularly on stage and children~'s television in the 1970s and 80s, before going on to play the seventh incarnation of the Doctor in the long-running science fiction television series Doctor Who - the final Doctor of the original run - and a brief return in a television film in 1996.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 8
      Doctor.Doctor     = 'Eight Doctor'
      Doctor.ActorName  = 'Paul McGann'
      Doctor.SeriesType = 'Classic'
      Doctor.StartYear  = 1996
      Doctor.EndYear    = 1996
      Doctor.Bio        = 'Paul John McGann (born 14 November 1959) is an English actor. He came to prominence for portraying Percy Toplis in the 1986 television serial The Monocled Mutineer. He later starred in the 1987 dark comedy Withnail and I, and as the eighth incarnation of the Doctor in the 1996 Doctor Who television film, a role he reprised in more than 70 audio dramas and the 2013 mini-episode "The Night of the Doctor".'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 9
      Doctor.Doctor     = 'The War Doctor'
      Doctor.ActorName  = 'John Hurt'
      Doctor.SeriesType = 'New'
      Doctor.StartYear  = 2013
      Doctor.EndYear    = 2013
      Doctor.Bio        = 'Sir John Vincent Hurt, CBE (born 22 January 1940)[1] is an English actor. Among other honours, he has received two Academy Award nominations, a Golden Globe Award, and four BAFTA Awards, with the fourth being a Lifetime Achievement recognition for his outstanding contribution to British cinema.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 10
      Doctor.Doctor     = 'Ninth Doctor'
      Doctor.ActorName  = 'Christopher Eccleston'
      Doctor.SeriesType = 'New'
      Doctor.StartYear  = 2005
      Doctor.EndYear    = 2005
      Doctor.Bio        = 'Eccleston played the Ninth Doctor in the British television series Doctor Who and is very full of himself.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 11
      Doctor.Doctor     = 'Tenth Doctor'
      Doctor.ActorName  = 'David Tennant'
      Doctor.SeriesType = 'New'
      Doctor.StartYear  = 2005
      Doctor.EndYear    = 2010
      Doctor.Bio        = 'David Tennant (born David John McDonald; 18 April 1971) is a Scottish actor known for his roles as the Tenth Doctor in the British television series Doctor Who, Alec Hardy in Broadchurch, Giacomo Casanova in the TV serial Casanova (2005) and Barty Crouch, Jr. in the film Harry Potter and the Goblet of Fire (2005).'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 12
      Doctor.Doctor     = 'Eleventh Doctor'
      Doctor.ActorName  = 'Matt Smith'
      Doctor.SeriesType = 'New'
      Doctor.StartYear  = 2010
      Doctor.EndYear    = 2013
      Doctor.Bio        = 'Matthew Robert "Matt" Smith (born 28 October 1982) is an English actor and director. He is best known for his role as the Eleventh Doctor in the BBC sci-fi series Doctor Who, for which he received a BAFTA Award nomination in 2011.'.
    CREATE Doctor.
    ASSIGN 
      Doctor.Doctor_no  = 13
      Doctor.Doctor     = 'Twelfth Doctor'
      Doctor.ActorName  = 'Peter Capaldi'
      Doctor.SeriesType = 'New'
      Doctor.StartYear  = 2014
      Doctor.EndYear    = 2016
      Doctor.Bio        = 'Peter Dougan Capaldi (born 14 April 1958) is a Scottish actor and film director. He has played numerous roles in film and television, and is best known for being the twelfth and current actor to play the lead role in in the long-running BBC One science-fiction series Doctor Who, and for the role of Malcolm Tucker, a spin doctor in the BBC comedy series The Thick of It and its film spinoff In the Loop.'.
    RETURN.

  END METHOD.

END CLASS.