/* 
   http://localhost/scripts/DoctorAPI.wsc/webservice/Doctor.p?method=get
   http://localhost/scripts/DoctorAPI.wsc/webservice/Doctor.p?Method=get&filterField=SeriesType&filterValue=New   
   
   BETTER -----------
   http://localhost/scripts/DoctorAPI.wsc/webservice/Doctor.p?Method=get&SeriesType=New   
   http://localhost/scripts/DoctorAPI.wsc/webservice/Doctor.p?Method=get&filter={SeriesType:New}   
   
 */ 

{src/web2/wrap-cgi.i} 
{DoctorTT.i}

DEFINE VARIABLE strMethod AS CHARACTER NO-UNDO.
 
strMethod = get-value("Method"). 

CASE strMethod:
    WHEN "get" THEN 
    RUN getDoctor.
    OTHERWISE  
    RUN ErrorOut ("Invalid Method: " + strMethod).
END CASE. 

/*------------------------------------------------------------------------------*/
PROCEDURE ErrorOut:
    DEFINE INPUT PARAMETER pError AS CHARACTER NO-UNDO.

    RUN outputhttpheader IN web-utilities-hdl ("status","500 " + pError).
    RUN OutputHttpHeader IN web-utilities-hdl ("", "").  /* blank line needed to get good error instead of 502 */
    RETURN.  
END PROCEDURE.

/*------------------------------------------------------------------------------*/
PROCEDURE getDoctor:
    DEFINE VARIABLE vFilterField AS CHARACTER        NO-UNDO. 
    DEFINE VARIABLE vFilterValue AS CHARACTER        NO-UNDO.
    DEFINE VARIABLE doctorDBUtil AS App.DoctorDBUtil.
   
    vFilterField = get-field ('filterField').
    vFilterValue = get-field ('filterValue'). 
 
    /* fill the TT base on passed filter criteria (if any) */
    doctorDBUtil = NEW App.DoctorDBUtil(). 
    doctorDBUtil:getDoctors (INPUT vFilterField, INPUT vFilterValue, OUTPUT TABLE ttDoctor). 
 
    /* send the JSON out through the web stream */ 
    RUN outputHeader (INPUT TEMP-TABLE ttDoctor:SERIALIZE-NAME).
    TEMP-TABLE ttDoctor:WRITE-JSON ("STREAM", "WEBSTREAM", TRUE, ?, FALSE, TRUE).  
  
    CATCH e AS Progress.Lang.Error:
        RUN ErrorOut (e:getMessage (1)).
        RETURN .
    END CATCH.

END PROCEDURE.

/*------------------------------------------------------------------------------*/
PROCEDURE outputHeader :
    DEFINE INPUT PARAMETER pName AS CHARACTER NO-UNDO. 
    /* give the output a pretty name, for no good reason */
    RUN OutputHttpHeader IN web-utilities-hdl ("Content-disposition", "attachment~; filename=~"" + pName + ".json"~"").
    output-content-type ("text/JSON":U).
END PROCEDURE.



